;Tabular exceptions:
;	NOP: Excluded because its opcode is $00, that wouldn't work well in a table. It is tested for uniquely.
;	DJNZ/JR: These are in the table for the Skeleton Layer, with false opcodes. They are tested uniquely in the Flesh Layer.
;	ld (ix+d),n / ld (iy+d),n: These are too complicated and unique to justify a unique algorithm.
;		Bogused in Skeleton, unique in Flesh


simpleasmtable:
					;this table handles all the one byte no argument instructions
					;**********begin table************
					;format is string (0 terminated), then the opcode
	.db "adc a,a",0,$8f
	.db "adc a,b",0,$88
	.db "adc a,c",0,$89
	.db "adc a,d",0,$8a
	.db "adc a,e",0,$8b

	.db "adc a,h",0,$8c
	.db "adc a,l",0,$8d
	.db "adc a,(hl)",0,$8e
	.db "add a,(hl)",0,$86
	.db "add a,a",0,$87

	.db "add a,b",0,$80
	.db "add a,c",0,$81
	.db "add a,d",0,$82
	.db "add a,e",0,$83
	.db "add a,h",0,$84

	.db "add a,l",0,$85
	.db "add hl,bc",0,$09
	.db "add hl,de",0,$19
	.db "add hl,hl",0,$29
	.db "add hl,sp",0,$39
	.db "and a",0,$a7
	.db "and b",0,$a0
	.db "and c",0,$a1
	.db "and d",0,$a2
	.db "and e",0,$a3
	.db "and h",0,$a4
	.db "and l",0,$a5
	.db "and (hl)",0,$a6
	.db 0
simpleasmctod
	.db "ccf",0,$3f
	.db "cp a",0,$bf
	.db "cp b",0,$b8
	.db "cp c",0,$b9
	.db "cp d",0,$ba
	.db "cp e",0,$bb
	.db "cp h",0,$bc
	.db "cp l",0,$bd
	.db "cp (hl)",0,$be
	.db "cpl",0,$2f
	.db "daa",0,$27
	.db "dec a",0,$3d
	.db "dec b",0,$05
	.db "dec c",0,$0d
	.db "dec d",0,$15
	.db "dec e",0,$1d
	.db "dec h",0,$25
	.db "dec l",0,$2d
	.db "dec (hl)",0,$35
	.db "dec bc",0,$0b
	.db "dec de",0,$1b
	.db "dec hl",0,$2b
	.db "dec sp",0,$3b
	.db "di",0,$f3
	.db 0
simpleasmetoi
	.db "ei",0,$fb
	.db "ex af,af'",0,$08
	.db "ex de,hl",0,$eb
	.db "ex (sp),hl",0,$e3
	.db "exx",0,$d9
	.db "halt",0,$76
	.db "inc a",0,$3c
	.db "inc b",0,$04
	.db "inc c",0,$0c
	.db "inc d",0,$14
	.db "inc e",0,$1c
	.db "inc h",0,$24
	.db "inc l",0,$2c
	.db "inc bc",0,$03
	.db "inc de",0,$13
	.db "inc hl",0,$23
	.db "inc sp",0,$33
	.db "inc (hl)",0,$34
	.db 0
simpleasmjtol
	.db "jp (hl)",0,$e9
	.db "ld (bc),a",0,$02
	.db "ld (de),a",0,$12
	.db "ld a,(bc)",0,$0a

	.db "ld a,(de)",0,$1a
	.db "ld sp,hl",0,$f9
	.db "ld a,a",0,$7f
	.db "ld a,b",0,$78
	.db "ld a,c",0,$79
	.db "ld a,d",0,$7a
	.db "ld a,e",0,$7b
	.db "ld a,h",0,$7c
	.db "ld a,l",0,$7d
	.db "ld b,a",0,$47
	.db "ld b,b",0,$40
	.db "ld b,c",0,$41
	.db "ld b,d",0,$42
	.db "ld b,e",0,$43
	.db "ld b,h",0,$44
	.db "ld b,l",0,$45
	.db "ld c,a",0,$4f
	.db "ld c,b",0,$48
	.db "ld c,c",0,$49
	.db "ld c,d",0,$4a
	.db "ld c,e",0,$4b
	.db "ld c,h",0,$4c
	.db "ld c,l",0,$4d
	.db "ld d,a",0,$57
	.db "ld d,b",0,$50
	.db "ld d,c",0,$51
	.db "ld d,d",0,$52
	.db "ld d,e",0,$53
	.db "ld d,h",0,$54
	.db "ld d,l",0,$55
	.db "ld e,a",0,$5f
	.db "ld e,b",0,$58
	.db "ld e,c",0,$59
	.db "ld e,d",0,$5a
	.db "ld e,e",0,$5b
	.db "ld e,h",0,$5c
	.db "ld e,l",0,$5d
	.db "ld h,a",0,$67
	.db "ld h,b",0,$60
	.db "ld h,c",0,$61
	.db "ld h,d",0,$62
	.db "ld h,e",0,$63
	.db "ld h,h",0,$64
	.db "ld h,l",0,$65
	.db "ld l,a",0,$6f
	.db "ld l,b",0,$68
	.db "ld l,c",0,$69
	.db "ld l,d",0,$6a
	.db "ld l,e",0,$6b
	.db "ld l,h",0,$6c
	.db "ld l,l",0,$6d
	.db "ld (hl),a",0,$77
	.db "ld (hl),b",0,$70
	.db "ld (hl),c",0,$71
	.db "ld (hl),d",0,$72
	.db "ld (hl),e",0,$73
	.db "ld (hl),h",0,$74
	.db "ld (hl),l",0,$75
	.db "ld sp,hl",0,$f9
	.db "ld a,(hl)",0,$7e
	.db "ld b,(hl)",0,$46
	.db "ld c,(hl)",0,$4e
	.db "ld d,(hl)",0,$56
	.db "ld e,(hl)",0,$5e
	.db "ld h,(hl)",0,$66
	.db "ld l,(hl)",0,$6e
	.db 0
simpleasmntor
	.db "or a",0,$b7
	.db "or b",0,$b0
	.db "or c",0,$b1
	.db "or d",0,$b2
	.db "or e",0,$b3
	.db "or h",0,$b4
	.db "or l",0,$b5
	.db "or (hl)",0,$b6
	.db "pop af",0,$f1		;because register pairs usually are bc,de,hl and sp
	.db "pop bc",0,$c1		;the pops and pushes are considered non-argumentitive.
	.db "pop de",0,$d1

	.db "pop hl",0,$e1
	.db "push af",0,$f5
	.db "push bc",0,$c5
	.db "push de",0,$d5
	.db "push hl",0,$e5
	.db "ret nz",0,$c0
	.db "ret z",0,$c8
	.db "ret nc",0,$d0
	.db "ret c",0,$d8
	.db "ret po",0,$e0
	.db "ret pe",0,$e8
	.db "ret p",0,$f0
	.db "ret m",0,$f8
	.db "ret",0,$c9
	.db "rla",0,$17
	.db "rlca",0,$07
	.db "rra",0,$1f
	.db "rrca",0,$0f
	.db "rst 00h",0,$c7
	.db "rst 08h",0,$cf
	.db "rst 10h",0,$d7
	.db "rst 08h",0,$df
	.db "rst 20h",0,$e7
	.db "rst 28h",0,$ef
	.db "rst 30h",0,$f7
	.db "rst 38h",0,$ff
	.db 0
simpleasmstox
	.db "sbc a,a",0,$9f
	.db "sbc a,b",0,$98
	.db "sbc a,c",0,$99
	.db "sbc a,d",0,$9a
	.db "sbc a,e",0,$9b
	.db "sbc a,h",0,$9c
	.db "sbc a,l",0,$9d
	.db "sbc a,(hl)",0,$9e
	.db "scf",0,$37
	.db "sub a",0,$97
	.db "sub b",0,$90
	.db "sub c",0,$91
	.db "sub d",0,$92
	.db "sub e",0,$93
	.db "sub h",0,$94
	.db "sub l",0,$95
	.db "sub (hl)",0,$96
	.db "xor a",0,$af
	.db "xor b",0,$a8
	.db "xor c",0,$a9
	.db "xor d",0,$aa
	.db "xor e",0,$ab
	.db "xor h",0,$ac
	.db "xor l",0,$ad
	.db "xor (hl)",0,$ae
	.db 0				;this 0 marks the end of the table.

easyasmtable:			;this is the no argument, 2 byte opcode table. same format as above table.

	.db "adc hl,bc",0,$ed,$4a
	.db "adc hl,de",0,$ed,$5a
	.db "adc hl,hl",0,$ed,$6a
	.db "adc hl,sp",0,$ed,$7a
	.db "add ix,bc",0,$dd,$09
	.db "add ix,de",0,$dd,$19
	.db "add ix,ix",0,$dd,$29
	.db "add ix,sp",0,$dd,$39
	.db "add iy,bc",0,$fd,$09
	.db "add iy,de",0,$fd,$19
	.db "add iy,iy",0,$fd,$29
	.db "add iy,sp",0,$fd,$39
	.db "bit 0,(hl)",0,$CB,$46
	.db "bit 1,(hl)",0,$CB,$4E
	.db "bit 2,(hl)",0,$CB,$56
	.db "bit 3,(hl)",0,$CB,$5E
	.db "bit 4,(hl)",0,$CB,$66
	.db "bit 5,(hl)",0,$CB,$6E
	.db "bit 6,(hl)",0,$CB,$76
	.db "bit 7,(hl)",0,$CB,$7E
	.db "bit 0,a",0,$CB,$47
	.db "bit 1,a",0,$CB,$4F
	.db "bit 2,a",0,$CB,$57
	.db "bit 3,a",0,$CB,$5F
	.db "bit 4,a",0,$CB,$67
	.db "bit 5,a",0,$CB,$6F
	.db "bit 6,a",0,$CB,$77
	.db "bit 7,a",0,$CB,$7F
	.db "bit 0,b",0,$CB,$40
	.db "bit 1,b",0,$CB,$48
	.db "bit 2,b",0,$CB,$50
	.db "bit 3,b",0,$CB,$58
	.db "bit 4,b",0,$CB,$60
	.db "bit 5,b",0,$CB,$68
	.db "bit 6,b",0,$CB,$70
	.db "bit 7,b",0,$CB,$78
	.db "bit 0,c",0,$CB,$41
	.db "bit 1,c",0,$CB,$49
	.db "bit 2,c",0,$CB,$51
	.db "bit 3,c",0,$CB,$59
	.db "bit 4,c",0,$CB,$61
	.db "bit 5,c",0,$CB,$69
	.db "bit 6,c",0,$CB,$71
	.db "bit 7,c",0,$CB,$79
	.db "bit 0,d",0,$CB,$42
	.db "bit 1,d",0,$CB,$4A
	.db "bit 2,d",0,$CB,$52
	.db "bit 3,d",0,$CB,$5A
	.db "bit 4,d",0,$CB,$62
	.db "bit 5,d",0,$CB,$6A
	.db "bit 6,d",0,$CB,$72
	.db "bit 7,d",0,$CB,$7A
	.db "bit 0,e",0,$CB,$43
	.db "bit 1,e",0,$CB,$4B
	.db "bit 2,e",0,$CB,$52
	.db "bit 3,e",0,$CB,$5B
	.db "bit 4,e",0,$CB,$63
	.db "bit 5,e",0,$CB,$6B
	.db "bit 6,e",0,$CB,$73
	.db "bit 7,e",0,$CB,$7B
	.db "bit 0,h",0,$CB,$44
	.db "bit 1,h",0,$CB,$4C
	.db "bit 2,h",0,$CB,$54
	.db "bit 3,h",0,$CB,$5C
	.db "bit 4,h",0,$CB,$64
	.db "bit 5,h",0,$CB,$6C
	.db "bit 6,h",0,$CB,$74
	.db "bit 7,h",0,$CB,$7C
	.db "bit 0,l",0,$CB,$45
	.db "bit 1,l",0,$CB,$4D
	.db "bit 2,l",0,$CB,$55
	.db "bit 3,l",0,$CB,$5D
	.db "bit 4,l",0,$CB,$65
	.db "bit 5,l",0,$CB,$6D
	.db "bit 6,l",0,$CB,$75
	.db "bit 7,l",0,$CB,$7D
	.db 0
easyasmctop
	.db "cpd",0,$ed,$a9
	.db "cpdr",0,$ed,$b9
	.db "cpi",0,$ed,$a1
	.db "cpir",0,$ed,$b1
	.db "dec ix",0,$dd,$2b
	.db "dec iy",0,$fd,$2b
	.db "djnz ",0,$00,$00		;This is only for the Skeleton Layer, the Flesh Layer will never encounter this entry.
	.db "ex (sp),ix",0,$dd,$e3

	.db "ex (sp),iy",0,$fd,$e3
	.db "im 0",0,$ed,$46
	.db "im 1",0,$ed,$56
	.db "im 2",0,$ed,$5e
	.db "in a,(c)",0,$ed,$78
	.db "in b,(c)",0,$ed,$40
	.db "in c,(c)",0,$ed,$48
	.db "in d,(c)",0,$ed,$50
	.db "in e,(c)",0,$ed,$58
	.db "in h,(c)",0,$ed,$60
	.db "in l,(c)",0,$ed,$68
	.db "inc ix",0,$dd,$23

	.db "inc iy",0,$fd,$23
	.db "ind",0,$ed,$aa
	.db "indr",0,$ed,$ba
	.db "ini",0,$ed,$a2
	.db "inir",0,$ed,$b2

	.db "jp (ix)",0,$dd,$e9
	.db "jp (iy)",0,$fd,$e9
	.db "jr ",0,$00,$00		;This is only for the Skeleton Layer, the Flesh Layer will never encounter this entry.
	.db "ld a,i",0,$ed,$57
	.db "ld i,a",0,$ed,$47
	.db "ld a,r",0,$ed,$5f

	.db "ld r,a",0,$ed,$4f
	.db "ld sp,ix",0,$dd,$f9
	.db "ld sp,iy",0,$fd,$f9
	.db "ldd",0,$ed,$a8
	.db "lddr",0,$ed,$b8
	.db "ldi",0,$ed,$a0
	.db "ldir",0,$ed,$b0
	.db "neg",0,$ed,$44
	.db "otdr",0,$ed,$bb
	.db "otir",0,$ed,$b3
	.db "out (c),a",0,$ed,$79
	.db "out (c),b",0,$ed,$41
	.db "out (c),c",0,$ed,$49
	.db "out (c),d",0,$ed,$51
	.db "out (c),e",0,$ed,$59
	.db "out (c),h",0,$ed,$61
	.db "out (c),l",0,$ed,$69
	.db "outd",0,$ed,$ab
	.db "outi",0,$ed,$a3
	.db "pop ix",0,$dd,$e1
	.db "pop iy",0,$fd,$e1
	.db "push ix",0,$dd,$e5
	.db "push iy",0,$fd,$e5
	.db 0
easyasmr
	.db "reti",0,$ed,$4d
	.db "retn",0,$ed,$45
	.db "rl a",0,$cb,$17
	.db "rl b",0,$cb,$10
	.db "rl c",0,$cb,$11
	.db "rl d",0,$cb,$12
	.db "rl e",0,$cb,$13
	.db "rl h",0,$cb,$14
	.db "rl l",0,$cb,$15
	.db "rl (hl)",0,$cb,$16
	.db "rlc a",0,$cb,$07
	.db "rlc b",0,$cb,$00
	.db "rlc c",0,$cb,$01
	.db "rlc d",0,$cb,$02
	.db "rlc e",0,$cb,$03
	.db "rlc h",0,$cb,$04
	.db "rlc l",0,$cb,$05
	.db "rlc (hl)",0,$cb,$06
	.db "rld",0,$ed,$6f
	.db "rr a",0,$cb,$1f
	.db "rr b",0,$cb,$18
	.db "rr c",0,$cb,$19
	.db "rr d",0,$cb,$1a
	.db "rr e",0,$cb,$1b
	.db "rr h",0,$cb,$1c
	.db "rr l",0,$cb,$1d
	.db "rr (hl)",0,$cb,$1e
	.db "rrc a",0,$cb,$0f
	.db "rrc b",0,$cb,$08
	.db "rrc c",0,$cb,$09
	.db "rrc d",0,$cb,$0a
	.db "rrc e",0,$cb,$0b
	.db "rrc h",0,$cb,$0c
	.db "rrc l",0,$cb,$0d
	.db "rrc (hl)",0,$cb,$0e
	.db "rrd",0,$ed,$67
	.db "res 0,a",0,$cb,$87
	.db "res 1,a",0,$cb,$8F
	.db "res 2,a",0,$cb,$97
	.db "res 3,a",0,$cb,$9F
	.db "res 4,a",0,$cb,$A7
	.db "res 5,a",0,$cb,$AF
	.db "res 6,a",0,$cb,$B7
	.db "res 7,a",0,$cb,$BF
	.db "res 0,b",0,$cb,$80
	.db "res 1,b",0,$cb,$88
	.db "res 2,b",0,$cb,$90
	.db "res 3,b",0,$cb,$98
	.db "res 4,b",0,$cb,$A0
	.db "res 5,b",0,$cb,$A8
	.db "res 6,b",0,$cb,$B0
	.db "res 7,b",0,$cb,$B8
	.db "res 0,c",0,$cb,$81
	.db "res 1,c",0,$cb,$89
	.db "res 2,c",0,$cb,$91
	.db "res 3,c",0,$cb,$99
	.db "res 4,c",0,$cb,$A1
	.db "res 5,c",0,$cb,$A9
	.db "res 6,c",0,$cb,$B1
	.db "res 7,c",0,$cb,$B9
	.db "res 0,d",0,$cb,$82
	.db "res 1,d",0,$cb,$8A
	.db "res 2,d",0,$cb,$92
	.db "res 3,d",0,$cb,$9A
	.db "res 4,d",0,$cb,$A2
	.db "res 5,d",0,$cb,$AA
	.db "res 6,d",0,$cb,$B2
	.db "res 7,d",0,$cb,$BA
	.db "res 0,e",0,$cb,$83
	.db "res 1,e",0,$cb,$8B
	.db "res 2,e",0,$cb,$93
	.db "res 3,e",0,$cb,$9B
	.db "res 4,e",0,$cb,$A3
	.db "res 5,e",0,$cb,$AB
	.db "res 6,e",0,$cb,$B3
	.db "res 7,e",0,$cb,$BB
	.db "res 0,h",0,$cb,$84
	.db "res 1,h",0,$cb,$8C
	.db "res 2,h",0,$cb,$94
	.db "res 3,h",0,$cb,$9C
	.db "res 4,h",0,$cb,$A4
	.db "res 5,h",0,$cb,$AC
	.db "res 6,h",0,$cb,$B4
	.db "res 7,h",0,$cb,$BC
	.db "res 0,l",0,$cb,$85
	.db "res 1,l",0,$cb,$8D
	.db "res 2,l",0,$cb,$95
	.db "res 3,l",0,$cb,$9D
	.db "res 4,l",0,$cb,$A5
	.db "res 5,l",0,$cb,$AD
	.db "res 6,l",0,$cb,$B5
	.db "res 7,l",0,$cb,$BD
	.db "res 0,(hl)",0,$CB,$86
	.db "res 1,(hl)",0,$CB,$8E
	.db "res 2,(hl)",0,$CB,$96
	.db "res 3,(hl)",0,$CB,$9E
	.db "res 4,(hl)",0,$CB,$A6
	.db "res 5,(hl)",0,$CB,$AE
	.db "res 6,(hl)",0,$CB,$B6
	.db "res 7,(hl)",0,$CB,$BE
easyasms:
	.db "sbc hl,bc",0,$ed,$42
	.db "sbc hl,de",0,$ed,$52
	.db "sbc hl,hl",0,$ed,$62
	.db "sbc hl,sp",0,$ed,$72
	.db "set 0,a",0,$CB,$C7
	.db "set 1,a",0,$CB,$CF
	.db "set 2,a",0,$CB,$D7
	.db "set 3,a",0,$CB,$DF
	.db "set 4,a",0,$CB,$E7
	.db "set 5,a",0,$CB,$EF
	.db "set 6,a",0,$CB,$F7
	.db "set 7,a",0,$CB,$FF
	.db "set 0,b",0,$CB,$C0
	.db "set 1,b",0,$CB,$C8
	.db "set 2,b",0,$CB,$D0
	.db "set 3,b",0,$CB,$D8
	.db "set 4,b",0,$CB,$E0
	.db "set 5,b",0,$CB,$E8
	.db "set 6,b",0,$CB,$F0
	.db "set 7,b",0,$CB,$F8
	.db "set 0,c",0,$CB,$C1
	.db "set 1,c",0,$CB,$C9
	.db "set 2,c",0,$CB,$D1
	.db "set 3,c",0,$CB,$D9
	.db "set 4,c",0,$CB,$E1
	.db "set 5,c",0,$CB,$E9
	.db "set 6,c",0,$CB,$F1
	.db "set 7,c",0,$CB,$F9
	.db "set 0,d",0,$CB,$C2
	.db "set 1,d",0,$CB,$CA
	.db "set 2,d",0,$CB,$D2
	.db "set 3,d",0,$CB,$DA
	.db "set 4,d",0,$CB,$E2
	.db "set 5,d",0,$CB,$EA
	.db "set 6,d",0,$CB,$F2
	.db "set 7,d",0,$CB,$FA
	.db "set 0,e",0,$CB,$C3
	.db "set 1,e",0,$CB,$CB
	.db "set 2,e",0,$CB,$D3
	.db "set 3,e",0,$CB,$DB
	.db "set 4,e",0,$CB,$E3
	.db "set 5,e",0,$CB,$EB
	.db "set 6,e",0,$CB,$F3
	.db "set 7,e",0,$CB,$FB
	.db "set 0,h",0,$CB,$C4
	.db "set 1,h",0,$CB,$CC
	.db "set 2,h",0,$CB,$D4
	.db "set 3,h",0,$CB,$DC
	.db "set 4,h",0,$CB,$E4
	.db "set 5,h",0,$CB,$EC
	.db "set 6,h",0,$CB,$F4
	.db "set 7,h",0,$CB,$FC
	.db "set 0,l",0,$CB,$C5
	.db "set 1,l",0,$CB,$CD
	.db "set 2,l",0,$CB,$D5
	.db "set 3,l",0,$CB,$DD
	.db "set 4,l",0,$CB,$E5
	.db "set 5,l",0,$CB,$ED
	.db "set 6,l",0,$CB,$F5
	.db "set 7,l",0,$CB,$FD
	.db "sla a",0,$cb,$27
	.db "sla b",0,$cb,$20
	.db "sla c",0,$cb,$21
	.db "sla d",0,$cb,$22
	.db "sla e",0,$cb,$23
	.db "sla h",0,$cb,$24
	.db "sla l",0,$cb,$25
	.db "sla (hl)",0,$cb,$26
	.db "sra a",0,$cb,$2f
	.db "sra b",0,$cb,$28
	.db "sra c",0,$cb,$29
	.db "sra d",0,$cb,$2a
	.db "sra e",0,$cb,$2b
	.db "sra h",0,$cb,$2c
	.db "sra l",0,$cb,$2d
	.db "sra (hl)",0,$cb,$2e
	.db "srl a",0,$cb,$3f
	.db "srl b",0,$cb,$38
	.db "srl c",0,$cb,$39
	.db "srl d",0,$cb,$3a
	.db "srl e",0,$cb,$3b
	.db "srl h",0,$cb,$3c
	.db "srl l",0,$cb,$3d
	.db "srl (hl)",0,$cb,$3e
	.db 0				;again, denotes end of table.
OKAsmTable:
					;In here we handle 3 byte indexed addressing. The first 2 bytes are opcode
					;the third byte (not supplied from table) is the immediate data.

					;Only opcodes where the two positions after the string are the HEX
					;byte for immediate data are included herein.
	.db "adc a,(ix+",0,$DD,$8E
	.db "adc a,(iy+",0,$FD,$8E
	.db "add a,(ix+",0,$DD,$86
	.db "add a,(iy+",0,$FD,$86
	.db "and (ix+",0,$DD,$A6
	.db "and (iy+",0,$FD,$A6
	.db "cp (ix+",0,$DD,$BE
	.db "cp (iy+",0,$FD,$BE
	.db "dec (ix+",0,$DD,$35
	.db "dec (iy+",0,$FD,$35
	.db "inc (ix+",0,$DD,$34
	.db "inc (iy+",0,$FD,$34
	.db "ld a,(ix+",0,$DD,$7E
	.db "ld b,(ix+",0,$DD,$46
	.db "ld c,(ix+",0,$DD,$4E
	.db "ld d,(ix+",0,$DD,$56
	.db "ld e,(ix+",0,$DD,$5E
	.db "ld h,(ix+",0,$DD,$66
	.db "ld l,(ix+",0,$DD,$6E
	.db "ld a,(iy+",0,$FD,$7E
	.db "ld b,(iy+",0,$FD,$46
	.db "ld c,(iy+",0,$FD,$4E
	.db "ld d,(iy+",0,$FD,$56
	.db "ld e,(iy+",0,$FD,$5E
	.db "ld h,(iy+",0,$FD,$66
	.db "ld l,(iy+",0,$FD,$6E
	.db "or (ix+",0,$DD,$B6
	.db "or (iy+",0,$FD,$B6
	.db "sbc (ix+",0,$DD,$9E
	.db "sbc (iy+",0,$FD,$9E
	.db "sub (ix+",0,$DD,$96
	.db "sub (iy+",0,$FD,$96
	.db "xor (ix+",0,$DD,$AE
	.db "xor (iy+",0,$FD,$AE
	.db 0				;EOT (End of Table)
HardAsmTable:
					;4 byte opcodes, where the third byte is immediate. Thus, the bytes
					;given in the table are 1,2 and 4.
	.db "bit 0,(ix+",0,$DD,$CB,$46
	.db "bit 1,(ix+",0,$DD,$CB,$4E
	.db "bit 2,(ix+",0,$DD,$CB,$56
	.db "bit 3,(ix+",0,$DD,$CB,$5E
	.db "bit 4,(ix+",0,$DD,$CB,$66
	.db "bit 5,(ix+",0,$DD,$CB,$6E
	.db "bit 6,(ix+",0,$DD,$CB,$76
	.db "bit 7,(ix+",0,$DD,$CB,$7E
	.db "bit 0,(ix+",0,$FD,$CB,$46
	.db "bit 1,(ix+",0,$FD,$CB,$4E
	.db "bit 2,(ix+",0,$FD,$CB,$56
	.db "bit 3,(ix+",0,$FD,$CB,$5E
	.db "bit 4,(ix+",0,$FD,$CB,$66
	.db "bit 5,(ix+",0,$FD,$CB,$6E
	.db "bit 6,(ix+",0,$FD,$CB,$76
	.db "bit 7,(ix+",0,$FD,$CB,$7E
	.db 0
hardasmr
	.db "res 0,(ix+",0,$DD,$CB,$86
	.db "res 1,(ix+",0,$DD,$CB,$8E
	.db "res 2,(ix+",0,$DD,$CB,$96
	.db "res 3,(ix+",0,$DD,$CB,$9E
	.db "res 4,(ix+",0,$DD,$CB,$A6
	.db "res 5,(ix+",0,$DD,$CB,$AE
	.db "res 6,(ix+",0,$DD,$CB,$B6
	.db "res 7,(ix+",0,$DD,$CB,$BE
	.db "res 0,(iy+",0,$FD,$CB,$86
	.db "res 1,(iy+",0,$FD,$CB,$8E
	.db "res 2,(iy+",0,$FD,$CB,$96
	.db "res 3,(iy+",0,$FD,$CB,$9E
	.db "res 4,(iy+",0,$FD,$CB,$A6
	.db "res 5,(iy+",0,$FD,$CB,$AE
	.db "res 6,(iy+",0,$FD,$CB,$B6
	.db "res 7,(iy+",0,$FD,$CB,$BE
	.db "rl (ix+",0,$DD,$CB,$16
	.db "rl (iy+",0,$FD,$CB,$16
	.db "rlc (ix+",0,$DD,$CB,$06
	.db "rlc (iy+",0,$FD,$CB,$06
	.db "rr (ix+",0,$DD,$CB,$1E
	.db "rr (iy+",0,$FD,$CB,$1E
	.db "rrc (ix+",0,$DD,$CB,$0E
	.db "rrc (iy+",0,$FD,$CB,$0E
	.db 0
hardasms
	.db "set 0,(ix+",0,$DD,$CB,$C6
	.db "set 1,(ix+",0,$DD,$CB,$CE
	.db "set 2,(ix+",0,$DD,$CB,$D6
	.db "set 3,(ix+",0,$DD,$CB,$DE
	.db "set 4,(ix+",0,$DD,$CB,$E6
	.db "set 5,(ix+",0,$DD,$CB,$EE
	.db "set 6,(ix+",0,$DD,$CB,$F6
	.db "set 7,(ix+",0,$DD,$CB,$FE
	.db "set 0,(iy+",0,$FD,$CB,$C6
	.db "set 1,(iy+",0,$FD,$CB,$CE
	.db "set 2,(iy+",0,$FD,$CB,$D6
	.db "set 3,(iy+",0,$FD,$CB,$DE
	.db "set 4,(iy+",0,$FD,$CB,$E6
	.db "set 5,(iy+",0,$FD,$CB,$EE
	.db "set 6,(iy+",0,$FD,$CB,$F6
	.db "set 7,(iy+",0,$FD,$CB,$FE
	.db "sla (ix+",0,$DD,$CB,$26
	.db "sla (iy+",0,$FD,$CB,$26
	.db "sra (ix+",0,$DD,$CB,$2E
	.db "sra (iy+",0,$FD,$CB,$2E
	.db "srl (ix+",0,$DD,$CB,$3E
	.db "srl (iy+",0,$FD,$CB,$3E
	.db 0
HarderAsmTable:
					;This handles 3 byte instructions where the last 2 bytes
					;are an immediate word. This should support labels as well.
	.db "bcall(",0,$EF

	.db "call nz,",0,$C4
	.db "call z,",0,$CC
	.db "call nc,",0,$D4
	.db "call c,",0,$DC
	.db "call po,",0,$E4
	.db "call pe,",0,$EC
	.db "call p,",0,$F4
	.db "call m,",0,$FC
	.db "call ",0,$CD

	.db "jp nz,",0,$C2
	.db "jp z,",0,$CA
	.db "jp nc,",0,$D2
	.db "jp c,",0,$DA
	.db "jp po,",0,$E2
	.db "jp pe,",0,$EA
	.db "jp p,",0,$F2
	.db "jp m,",0,$FA
	.db "jp ",0,$C3

	.db "ld hl,(",0,$2A
	.db "ld (*,hl",0,$22

	.db "ld bc,",0,$01
	.db "ld de,",0,$11
	.db "ld hl,",0,$21
	.db "ld sp,",0,$31

	.db "ld a,(",0,$3A
	.db "ld (*,a",0,$32
	.db 0
DifficultAsmTable:
					;This handles 4 byte instructions with first 2 bytes opcode
					;and second 2 immediate word. Labels should be allowed for the word.
					;n in the string is wildcard. A wildcard ignores all bytes until a ) is found.
					;Thus, a ) is implicit in the n.

	.db "ld (*,ix",0,$00,$00		;These two are bogus, for Skeleton layer only.
	.db "ld (*,iy",0,$00,$00

	.db "ld bc,(",0,$ED,$4B
	.db "ld de,(",0,$ED,$5B
	.db "ld hl,(",0,$ED,$6B
	.db "ld sp,(",0,$ED,$7B

	.db "ld (*,bc",0,$ED,$43
	.db "ld (*,de",0,$ED,$53
		;There is a ld (nnnn),hl with opcode $ED,$63,nn,nn; but why use it when you could use $22,nn,nn?
	.db "ld (*,sp",0,$ED,$73

	.db "ld (*,ix",0,$DD,$22
	.db "ld (*,iy",0,$FD,$22

	.db "ld ix,(",0,$DD,$2A
	.db "ld iy,(",0,$FD,$2A

	.db "ld ix,",0,$DD,$21
	.db "ld iy,",0,$FD,$21
	.db 0
facileasmtable:

					;it is important to note that if this
					;table were processed too soon
					;there would be problems.

					;this table contains 2 byte instructions
					;where the first byte is constant and the
					;second byte is immediate, the last 2 bytes

					;Only opcodes where the two positions after the string are the HEX
					;byte for immediate data are included herein.
	.db "adc a,",0,$ce
	.db "add a,",0,$c6
	.db "and ",0,$e6
	.db "cp ",0,$fe
	.db "ld a,",0,$3e
	.db "ld b,",0,$06
	.db "ld c,",0,$0e
	.db "ld d,",0,$16
	.db "ld e,",0,$1e
	.db "ld h,",0,$26
	.db "ld l,",0,$2e
	.db "ld (hl),",0,$36
	.db "or ",0,$f6
	.db "out (n),a",$D3
	.db "sbc a,",0,$de
	.db "sub ",0,$d6
	.db "xor ",0,$ee
	.db "in a,(",0,$DB
	.db 0				;not to sound like a broken record, this marks the end of the table.