StringToHex:				;IN: HL points to first byte of 2 byte string
						;containing 1 hex byte
						;OUT: HL points to 2nd byte
						;A=value
						;DESTROYS: B

	ld a,(hl)				;16's place
	call CharToHex
	add a,a
	add a,a
	add a,a
	add a,a
	inc hl
	ld b,a
	ld a,(hl)
	call CharToHex
	add a,b						;So now A=the number in the source
	ret
CharToHex:						;A=TOKEN of 1 hex digit (0-F)
							;Out is A=$00-$0F
	cp $41
							;NC if A=>$41 IE, its A-F
	jp c,STHdontsub7
	sub 7
STHdontsub7
	sub $30
	ret
Error_Duplicate:
	ld hl,errdupetxt
	jr Jen_Error
NoValidFiles:
	ld hl,nofilestxt
	jr Jen_Error
NotEnoughMem:
	ld hl,NotEnoughMemTxt
Jen_Error:
	push hl
	call scnclr
	pop hl
	call PutIts
	bcall(_GetKey)
	jp mainmnu
EnlargeOutputByOne:
	ld bc,1
EnlargeOutput
	ld hl,outputname
EnlargeVar:					;IN: HL points to variable name to resize
						;OUT: Variable has 1 more in size bytes
						;DESTROYS: Assume everything
	push bc
	bcall(_Mov9ToOP1)
	bcall(_ChkFindSym)
	ex de,hl
	pop bc
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	add hl,bc
	ex de,hl
	ld (hl),d
	dec hl
	ld (hl),e
	ret
scnclr:
	bcall(_GrBufClr)
	bcall(_ClrLCDFull)
	ld hl,0
	ld (currow),hl
	ld (pencol),hl
	xor a
	ret
compstrsn:			;Although based on the MirageOS
				;input/output, I wrote the actual code myself.
				;These aren't that challenging;)
	ld a,(de)
	cp (hl)
	inc hl
	inc de
	ret nz
	djnz compstrsn
	ret
lenstr:				;Finds number of bytes from (HL)
				;to the next $00 counting (HL) but not $00.
				;C=length of string
	xor a
	ld c,a
lenstr_lp
	cp (hl)
	ret z
	inc hl
	inc c
	jr lenstr_lp
prevstr:		;HL points to string's 0 terminator. Returns start



	ld hl,(IParseStart)
	ret



	xor a
prevstr_lp
	dec hl
	cp (hl)
	jr z,prevstr_done
	jr prevstr_lp
prevstr_done
	inc hl
	ret
compstrs:			;Note that this returns Z immediatly after finding a 0 in DE
				;Thus, if HL->"HI WORLD",0 and DE->"HI",0 compstrs will return Z
				;*'s in HL are wildcard; they ignore everything until a ) is found.
				;Returns BC->the first n byte, if none then the byte following the identifier string.
	ex de,hl
	push hl
	call lenstr
	pop hl
	ex de,hl
	push hl
	ld b,0
	add hl,bc
	push hl
	pop bc
	pop hl
compstrslp
	ld a,(de)
	or a
	ret z
	cp '*'
	jr z,compstrsDoWild
	cp (hl)
	ret nz
	inc hl
	inc de
	jr compstrslp
compstrsDoWild
	push hl
	pop bc
	inc de
	ld a,')'
cDoWildLoop
	cp (hl)
	inc hl
	jr z,compstrslp
	jr cDoWildLoop
;From TSE libraries by Michael Vincent and Robin Kay
;Modified to suit my nefarious purposes heh heh heh...
;<TSE_CODE>
;---------= Fast Copy =---------
;Input:	nothing
;Output:graph buffer is copied to the screen
;
fastCopy:
 di
 ld      a,$80
 out     ($10),a
 ld      hl,plotsscreen-12-(-(12*64)+1)
 ld      a,$20
 ld      c,a
 inc hl
 dec hl
fastCopyAgain:
 ld      b,64
 inc     c
 ld      de,-(12*64)+1
 out     ($10),a
 add     hl,de
 ld      de,0ah
fastCopyLoop:
 add     hl,de
 inc     hl
 inc     hl
 inc     de
 ld      a,(hl)
 out     ($11),a
 dec     de
 djnz    fastCopyLoop
 ld      a,c
 cp      $2B+1
 jr      nz,fastCopyAgain
 ei
 ret
;---------= XOR a sprite =---------
; l=yc
; a=xc
; ix holds pointer
tsesprite:
	ld b,5
lllsprite:
 ld      e,l
 ld      h,$00
 ld      d,h
 add     hl,de
 add     hl,de
 add     hl,hl
 add     hl,hl
 ld      e,a
 and     $07
 ld      c,a
 srl     e
 srl     e
 srl     e
 add     hl,de
 ld      de,plotsscreen
 add     hl,de
lllsl1:
 ld      d,(ix)
 ld      e,$00
 ld      a,c
 or      a
 jr      z,lllsl3
lllsl2:
 srl     d
 rr      e
 dec     a
 jr      nz,lllsl2
lllsl3:
 ld      a,(hl)
 xor     d
 ld      (hl),a
 inc     hl
 ld      a,(hl)
 xor     e
 ld      (hl),a
 ld      de,$0B
 add     hl,de
 djnz    lllsl1
 ret
;</TSE_CODE>
nextstr:				;This finds the next DE str, not HL like in MirageOS.
	ld a,(de)
	inc de
	or a
	ret z
	jr nextstr
nextstra:			;IN: HL->string, A=# of strings to find (0=this one)
	or a
	ret z
	ld b,a
	call nextstr
	djnz nextstra+3
	ret
PutIts:				;PutS, but using PutC
	ld a,(hl)
	or a
	ret z
	bcall(_PutC)
	inc hl
	jp PutIts
VPutFunny:
	ld a,(hl)
	or a
	ret z
	cp 32
	jr nz,notSpcChngadsfaaa
	ld a,6
notSpcChngadsfaaa
	bcall(_VPutMap)
	inc hl
	jp VPutFunny

DispCur:
				;Display cursor
				;A=x, L=y, D=Width
				;Adapted from TSE Sprite
	push af
	ld b,0
	ld c,d
	ld de,bincurtable
	ex de,hl
	add hl,bc
	ex de,hl
	ld a,(de)
	ld d,a
	pop af
	push de
	ld b,5
	ld      e,l
	ld      h,$00
	ld      d,h
	add     hl,de
	add     hl,de
	add     hl,hl
	add     hl,hl
	ld      e,a
	and     $07
	ld      c,a
	srl     e
	srl     e
	srl     e
	add     hl,de
	ld      de,plotsscreen
	add     hl,de
sl1:
	pop de
	push de
	ld a,(hl)
	res 7,a
	bit 6,d
	jr z,CurReadyToXor
	res 6,a
	bit 5,d
	jr z,CurReadyToXor
	res 5,a
	bit 4,d
	jr z,CurReadyToXor
	res 4,a
	bit 3,d
	jr z,CurReadyToXor
	res 3,a
	bit 2,d
	jr z,CurReadyToXor
	res 2,a
	bit 1,d
	jr z,CurReadyToXor
	res 1,a
	bit 0,d
	jr z,CurReadyToXor
	res 0,a
CurReadyToXor
	ld (hl),a
	ld      e,$00
	ld      a,c
	or      a
	jr      z,sl3
sl2:
	srl     d
	rr      e
	dec     a
	jr      nz,sl2
sl3:
	ld a,(hl)
	xor d
	ld      (hl),a
	inc     hl
	ld      a,(hl)
	xor	e
	ld      (hl),a
	ld      de,$0B
	add     hl,de
	djnz    sl1
	pop de
	ret
PutByte:						;Puts A into the output file, and updates pointer
	ld de,(outpointer)
	ld (de),a
	inc de
	ld (outpointer),de
	ret
compstrs_old_school:					;Returns the 0 byte of hl
	ld a,(de)
	cp (hl)
	ret nz
	or a
	ret z
	inc de
	inc hl
	jr compstrs_old_school
GetLabelOrHex:
						;IN: HL->hex word or label
						;We do this pretty simply: If the string is in the defineprgm file, then it is a label.
						;If it's 4 bytes and not in the file, it is a hex word.
						;If it's neither, interpet it like a hex word until I put some error trapping in.

						;It returns C as upper order and A as lower order
	ex de,hl
	ld hl,(defineprgm)	;Remember (defineprgm) points to the size byte
	inc hl
	inc hl
labelhexloop
	push de
	ld de,(definepointer)
	bcall(_CpHLDE)
	pop de
	jr z,labelhexinterpolate
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	push hl
	push de
	call compstrs_old_school
	pop de
	pop hl
	jr z,labelhexfound
	ex de,hl
	call nextstr
	ex de,hl
	dec hl		;Wierd, I know. labelhexloop needs HL->0 of previous label (or leading 0) in order for the loop to terminate
			;In retrospect I should have used a sentinel or counter instead. Oh well.
	jr labelhexloop
labelhexfound
	ld a,c
	ld c,b
	ret
labelhexinterpolate
	ex de,hl
	call StringToHex
	ld c,a
	inc hl
	call StringToHex
	ret